/*
Module : PyDebugCallStackWnd.h
Purpose: Defines the interface for the classes which encapsulate the Call Stack window functionality of PyDebug++
Created: PJN / 20-08-2015

Copyright (c) 2015 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once


#ifndef __PYDEBUGCALLSTACKWND_H__
#define __PYDEBUGCALLSTACKWND_H__

#ifndef CPYDEBUG_EXT_CLASS
#define CPYDEBUG_EXT_CLASS
#endif //#ifndef CPYDEBUG_EXT_CLASS


//////////////////// Classes //////////////////////////////////////////////////

class CPyDebugFrameWnd;


class CPYDEBUG_EXT_CLASS CPyDebugCallStackListCtrl : public CListCtrl
{
protected:
//Member variables
  CPyDebugFrameWnd* m_pMainFrame{nullptr};

//Message handlers
  afx_msg void OnNMDblclk(_In_ NMHDR* pNMHDR, _Inout_ LRESULT* pResult);

  DECLARE_MESSAGE_MAP()

  friend class CPyDebugCallStackWnd;
};


class CPYDEBUG_EXT_CLASS CPyDebugCallStackWnd : public CDockablePane
{
public:
//Methods
  void SePyDebugMainFrame(_In_opt_ CPyDebugFrameWnd* pMainFrame) noexcept;

//Member variables
  CPyDebugCallStackListCtrl m_wndCtrl;

protected:
//Member variables
  CImageList m_ImageList;
  CPyDebugFrameWnd* m_pMainFrame{nullptr};

  //Message handlers
  afx_msg int OnCreate(_In_ LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(_In_ UINT nType, _In_ int cx, _In_ int cy);
  afx_msg void OnSetFocus(_In_opt_ CWnd* pOldWnd);

  DECLARE_MESSAGE_MAP()
};


#endif //#ifndef __PYDEBUGCALLSTACKWND_H__
