/*
Module : PyDebugDocTemplate.h
Purpose: Defines the interface for the class which implements the MFC Doc template functionality of PyDebug++
Created: PJN / 01-09-2015

Copyright (c) 2015 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __PYDEBUGDOCTEMPLATE_H__
#define __PYDEBUGDOCTEMPALTE_H__

#ifndef CPYDEBUG_EXT_CLASS
#define CPYDEBUG_EXT_CLASS
#endif //#ifndef CPYDEBUG_EXT_CLASS


//////////////////// Classes //////////////////////////////////////////////////

class CPyDebugFrameWnd;

class CPYDEBUG_EXT_CLASS CPyDebugMultiDocTemplate : public CMultiDocTemplate
{
public:
//Constructors / Destructors
  CPyDebugMultiDocTemplate(_In_ UINT nIDResource, _In_ CRuntimeClass* pDocClass, _In_ CRuntimeClass* pFrameClass, _In_ CRuntimeClass* pViewClass);
  CPyDebugMultiDocTemplate(const CPyDebugMultiDocTemplate&) = delete;
  CPyDebugMultiDocTemplate(CPyDebugMultiDocTemplate&&) = delete;
  ~CPyDebugMultiDocTemplate() = default; //NOLINT(modernize-use-override)

//Methods
  CPyDebugMultiDocTemplate& operator=(const CPyDebugMultiDocTemplate&) = delete;
  CPyDebugMultiDocTemplate& operator=(CPyDebugMultiDocTemplate&&) = delete;
  void SetPyDebugFrameWnd(_In_ CPyDebugFrameWnd* pFrameWnd) noexcept;
  CFrameWnd* CreateNewFrame(CDocument* pDoc, CFrameWnd* pOther) override;
  CDocument* OpenDocumentFile(LPCTSTR lpszPathName, BOOL bMakeVisible = TRUE) override;

protected:
//Member variables
  CPyDebugFrameWnd* m_pFrameWnd;
};


#endif //#ifndef __PYDEBUGDOCTEMPLATE_H__
